DmtEventListener
Date: 2016-06-25

org.osgi.service.dmt

## Interface DmtEventListener

-     public interface DmtEventListener

  Registered implementations of this class are notified via `DmtEvent` objects about important changes in the tree. Events are generated after every successful DMT change, and also when sessions are opened or closed. If a `DmtSession` is opened in atomic mode, DMT events are only sent when the session is committed, when the changes are actually performed.

  Dmt Event Listener services must have permission `DmtPermission.GET` for the nodes in the `nodes` and `newNodes` property in the Dmt Event.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `FILTER_EVENT` A number of event types packed in a bitmap.
    `static java.lang.String` | `FILTER_PRINCIPAL` A number of names of principals.
    `static java.lang.String` | `FILTER_SUBTREE` A number of sub-tree top nodes that define the scope of the Dmt Event Listener.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `changeOccurred(DmtEvent event)` `DmtAdmin` uses this method to notify the registered listeners about the change.

- - ### Field Detail

    - #### FILTER_SUBTREE

          static final java.lang.String FILTER_SUBTREE

      A number of sub-tree top nodes that define the scope of the Dmt Event Listener. If this service property is registered then the service must only receive events for nodes that are part of one of the sub-trees. The type of this service property is `String+`.
      See Also:
        Constant Field Values

    - #### FILTER_PRINCIPAL

          static final java.lang.String FILTER_PRINCIPAL

      A number of names of principals. If this service property is provided with a Dmt Event Listener service registration than that listener must only receive events for which at least one of the given principals has `Get` rights. The type of this service property is `String+`.
      See Also:
        Constant Field Values

    - #### FILTER_EVENT

          static final java.lang.String FILTER_EVENT

      A number of event types packed in a bitmap. If this service property is provided with a Dmt Event Listener service registration than that listener must only receive events where one of the Dmt Event types occur in the bitmap. The type of this service property must be `Integer`.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### changeOccurred

          void changeOccurred(DmtEvent event)

      `DmtAdmin` uses this method to notify the registered listeners about the change. This method is called asynchronously from the actual event occurrence.
      Parameters:
        `event` - the `DmtEvent` describing the change in detail